// Correction de l'exercice
// Cette correction utilise un tableau dont l'indicie est une longueur de mot
//  et chaque valeur est un ArrayList qui contient les mots de meme longueur
//
public class Exercice
{
    public static void main(String args[])
    {
        // Saisie de la chaine a traiter
        //
        Terminal.ecrireStringln("Entrez la chaine:");
        String chaine = Terminal.lireString();

        // Les longueurs de mot ne peuvent depasser 100
        // Tableau de liste de mots
        //
        ArrayList[] tableau = new ArrayList[100];

        // On ajoute chacun des mots de la phrase dans la liste
        //  correspondante  la longueur du mot
        //
        StringTokenizer strtok = new StringTokenizer(chaine," ");
        while(strtok.hasMoreTokens())
            {
                String str = strtok.nextToken();
                if (tableau[str.length()]==null)
                    tableau[str.length()]=new ArrayList<String>();
                tableau[str.length()].add(str);
            }

        // On affiche toutes les listes de mots non vides en triant
        //  chaque liste
        //
        for(int i=0;i<100;i++)
            {
                if (tableau[i]!=null)
                    {
                        Collections.sort(tableau[i]);
                        for(Object s:tableau[i])
                            Terminal.ecrireString((String)s+" ");
                        Terminal.ecrireStringln("");
                    }
            }
        
    }
}
