// Correction de l'exercice
// Cette correction utilise un tableau dont l'indicie est une longueur de mot
//  et chaque valeur est une chaine contenant les mots espacs par 1 blanc
//
import java.util.*;
public class ExerciceCorrection2
{
    public static void main(String args[])
    {
        // Saisie de la chaine a traiter
        //
        Terminal.ecrireStringln("Entrez la chaine:");
        String chaine = Terminal.lireString();
        
        // Les longueurs de mot ne peuvent depasser 100
        // Tableau de liste de mots
        //
        String[] tableau = new String[100];

        // On ajoute chacun des mots de la phrase dans la liste
        //  correspondante  la longueur du mot
        //
        StringTokenizer strtok = new StringTokenizer(chaine," ");
        while(strtok.hasMoreTokens())
            {
                String str = strtok.nextToken();
                if (tableau[str.length()]==null)
                    tableau[str.length()]="";
                tableau[str.length()]=tableau[str.length()]+str+" ";
            }

        // On affiche toutes les listes de mots non vides en triant
        //  chaque liste
        //
        for(int i=0;i<100;i++)
            {
                if (tableau[i]!=null)
                    {
                        String[] motsTab = tableau[i].split(" ");
                        ArrayList<String> mots = new ArrayList<String>();
                        for(String s:motsTab) mots.add(s);
                        Collections.sort(mots);
                        for(String s:mots)
                            Terminal.ecrireString(s+" ");
                        Terminal.ecrireStringln("");
                    }
            }
        
    }
}
//1h00
